      program formatted
c
c   Criar um arquivo de estacoes WMO para os programas de
c   pre-processamento checarem informacoes das estacoes meteorologicas
c      ( WMO VOLUMEN A - LIST OF OBSERVING STATIONS)
c     a partir de arquivo formatado em ASCII 
c     coloca no formato que deve que sera utilizado pelos programas
c
c     autor: R.Cintra
c     Sept. 1999
c
      integer*2  bloc,blocant
      dimension iparams(33000),ipoints(128)
      integer icount,i,ip,ist,nwpt
c
      data ipoints/128*0/,iparams/33000*0/
      
      open(unit=23,file='formatted_station.dat',
     1             form='formatted',
     2             recl=80,
     2             status='new')
 
      open(unit=21,file='formatted_station.dat.amend',
     1             form='formatted',
     2             recl=80,
     2             status='old')
c
      blocant=0
      icount=0
      i=1
      nwpt=1
      nbpt=0
c
c     campos :
c        ISTNO = numero da estacao 
c        IPCODE = nivel de pressao
c        KNMS = medida do vento
c        ID = altitude da estacao
c        ILON = longitude
c        ILAT = latitude
c        ISGLAT = sinal da latidude
c        IRN  = numero da regiao
c        Icoun = numero do pais
c        ISTIND = estacao principal
c        ITYPE1 = TEMP
C        ITYPE2 = PILOT
C        ITYPE3 = SYNOP
c
c
100   read(21,'(I5,I3,i1,I5,2i7,2i1,i5,4i1)',iostat=ios,err=400,end=200) 
     1     ISTNO,IPCODE,KNMS,ID,ILON,ILAT,ISGLAT,
     1     IRN,ICOUN,ISTIND,ITYPE1,ITYPE2,ITYPE3
     
        IST = mod(istno,1000)
c
C          INDEXACAO DA TABELA PELO NUMERO DO BLOCO
c
       bloc = istno/1000

      if (bloc .le. 0 .or. bloc .gt. 99) then
        print*,'WMO Block number error',bloc,istno
        stop 100
      endif
      
      if (bloc .ne. blocant) then
       blocant = bloc
c       
c       ipoints apontam para o inicio do bloco
c
       do while (i.lt.bloc)
        ipoints(i) = nwpt
c         print*,'i=',i,ipoints(i)
        i=i+1
       enddo
       if (bloc .eq. 1) then
       ipoints(bloc) = 1
       else
       ipoints(bloc) = nwpt
       endif
c       print*,'bloc=',bloc,ipoints(bloc)
       i = i+1
      endif
      
      write(23,'(I3,I3,i1,I5,2i7,2i1,i5,4i1)',iostat=ios,err=403)
     1     IST,IPCODE,KNMS,ID,ILON,ILAT,ISGLAT,
     1     IRN,ICOUN,ISTIND,ITYPE1,ITYPE2,ITYPE3  
      
      nwpt = nwpt + 3
      icount = icount + 1
      
      go to 100

c
200   continue

      do ip = icount,11000
       ist=0
       ipcode=0
       knms=0
       id=0
       ilon=0
       ilat=0
       isglat=0
       irn=0
       icoun=0
       istind=0
       itype1=0
       itype2=0
       itype3=0
       write(23,'(I3,I3,i1,I5,2i7,2i1,i5,4i1)',iostat=ios,err=403)
     1     IST,IPCODE,KNMS,ID,ILON,ILAT,ISGLAT,
     1     IRN,ICOUN,ISTIND,ITYPE1,ITYPE2,ITYPE3
     
      enddo
      print*,'number of records ',ip-1
      print*,'Number of stations retreived ',icount
      print*,'Number of ipoints',i-1
      
      do i = 1,128
       print*,i, ipoints(i)
       write(23,'(i12)') ipoints(i)       
      enddo
      close(21)
      close(23)
      stop 0
c

 400  continue
      print*,'Error during read on file formatted',ios
      stop 400
      
 403  continue
      print*,'Error during write on file formatted',ios
      stop 403
      end
      
